'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var t = _ref.types;

  return {
    visitor: {
      ArrowFunctionExpression: function ArrowFunctionExpression(path, state) {
        var options = (0, _options2.default)(state);
        if (!path.parent.id || !path.parent.id.name) return;
        var componentName = path.parent.id.name;

        var functionBody = path.get('body').get('body');
        var returnStatement = functionBody.find(function (c) {
          return c.type === 'ReturnStatement';
        });
        var arg = returnStatement.get('argument');
        if (!arg.isJSXElement()) return;

        var openingElement = arg.get('openingElement');
        openingElement.node.attributes.push(t.jSXAttribute(t.jSXIdentifier(options.attribute), t.stringLiteral(options.format(componentName))));
      },
      ClassDeclaration: function ClassDeclaration(path, state) {
        var name = path.get('id');
        var properties = path.get('body').get('body');

        var render = properties.find(function (prop) {
          return prop.isClassMethod() && prop.get('key').isIdentifier({ name: 'render' });
        });

        if (!render || !render.traverse) {
          return;
        }

        var options = (0, _options2.default)(state);

        render.traverse({
          ReturnStatement: function ReturnStatement(returnStatement) {
            var arg = returnStatement.get('argument');
            if (!arg.isJSXElement()) return;

            var openingElement = arg.get('openingElement');
            openingElement.node.attributes.push(t.jSXAttribute(t.jSXIdentifier(options.attribute), t.stringLiteral(options.format(name.node && name.node.name))));
          }
        });
      }
    }
  };
};

var _options = require('./options');

var _options2 = _interopRequireDefault(_options);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }